# Interface SyWindowServiceType

All Superinterfaces:
  `com.io7m.repetoir.core.RPServiceType, SyServiceType`

public interface SyWindowServiceType extends SyServiceType
The window service.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `windowClose(SyWindowType window)`
  Close/destroy the window.
  `default SyWindowType`
  `windowCreate(int sizeX, int sizeY)`
  Create a new window.
  `SyWindowType`
  `windowCreateOnLayer(int sizeX, int sizeY, SyWindowLayerID layer)`
  Create a new window.
  `void`
  `windowFocus(SyWindowType window)`
  Bring `w` to the front.
  `void`
  `windowHide(SyWindowType window)`
  Hide the window.
  `boolean`
  `windowIsFocused(SyWindowType window)`
  `boolean`
  `windowIsVisible(SyWindowType window)`
  `SyWindowLayerID`
  `windowLayerDefault()`
  `SyWindowLayerID`
  `windowLayerForMenus()`
  `void`
  `windowMaximize(SyWindowType window)`
  Maximize the window.
  `SyWindowType`
  `windowMenu()`
  `void`
  `windowShow(SyWindowType window)`
  Make the window visible.
  `List<SyWindowType>`
  `windowsVisibleOrdered()`

  ### Methods inherited from interface com.io7m.repetoir.core.RPServiceType

  `description`

- ## Method Details

  - ### windowLayerDefault

    SyWindowLayerID windowLayerDefault()
    Returns:
      The default layer for windows

  - ### windowLayerForMenus

    SyWindowLayerID windowLayerForMenus()
    Returns:
      The default layer for menus

  - ### windowCreate

    default SyWindowType windowCreate(int sizeX, int sizeY)
    Create a new window.
    Parameters:
      `sizeX` - The window width
      `sizeY` - The window height
    Returns:
      A new window

  - ### windowCreateOnLayer

    SyWindowType windowCreateOnLayer(int sizeX, int sizeY, SyWindowLayerID layer)
    Create a new window.
    Parameters:
      `sizeX` - The window width
      `sizeY` - The window height
      `layer` - The window layer
    Returns:
      A new window

  - ### windowsVisibleOrdered

    List<SyWindowType> windowsVisibleOrdered()
    Returns:
      A read-only list of the currently open windows in order from nearest to furthest

  - ### windowIsFocused

    boolean windowIsFocused(SyWindowType window)
    Parameters:
      `window` - A window
    Returns:
      `true` iff `w` is currently isFocused

  - ### windowIsVisible

    boolean windowIsVisible(SyWindowType window)
    Parameters:
      `window` - A window
    Returns:
      `true` iff `w` is currently open

  - ### windowShow

    void windowShow(SyWindowType window)
    Make the window visible. The window, once visible, has focus. If the window is already visible, the window gains focus.
    Parameters:
      `window` - A window

  - ### windowHide

    void windowHide(SyWindowType window)
    Hide the window. If the window is already invisible, this has no effect.
    Parameters:
      `window` - A window

  - ### windowClose

    void windowClose(SyWindowType window)
    Close/destroy the window.
    Parameters:
      `window` - A window

  - ### windowFocus

    void windowFocus(SyWindowType window)
    Bring `w` to the front.
    Parameters:
      `window` - A window

  - ### windowMaximize

    void windowMaximize(SyWindowType window)
    Maximize the window.
    Parameters:
      `window` - A window

  - ### windowMenu

    SyWindowType windowMenu()
    Returns:
      A reference to the window used for menus